diff --git a/libglusterfs/src/glusterfs/common-utils.h b/libglusterfs/src/glusterfs/common-utils.h
index 7887a18ad45..9b011655b59 100644
--- a/libglusterfs/src/glusterfs/common-utils.h
+++ b/libglusterfs/src/glusterfs/common-utils.h
@@ -863,15 +863,15 @@ gf_time_fmt(char *dst, size_t sz_dst, time_t utime, unsigned int fmt)
 
 static inline size_t
 gf_time_fmt_tv_FT(char *dst, size_t sz_dst, struct timeval *tv,
-                  glusterfs_ctx_t *ctx)
+                  gf_log_handle_t *log)
 {
     struct tm tm, *res;
     int localtime = 0;
     int len = 0;
     int pos = 0;
 
-    if (ctx != NULL)
-        localtime = ctx->log.localtime;
+    if (log != NULL)
+        localtime = log->localtime;
     else
         localtime = gf_log_get_localtime();
     res = localtime ? localtime_r(&tv->tv_sec, &tm)
diff --git a/libglusterfs/src/logging.c b/libglusterfs/src/logging.c
index c303e2396cb..10c1663082e 100644
--- a/libglusterfs/src/logging.c
+++ b/libglusterfs/src/logging.c
@@ -869,7 +869,7 @@ _gf_log_callingfn(const char *domain, const char *file, const char *function,
     if (-1 == ret)
         goto out;
 
-    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
 
     ret = gf_asprintf(&logline, "[%s] %c [%s:%d:%s] %s %d-%s: %s\n", timestr,
                       gf_level_strings[level], basename, line, function,
@@ -1136,7 +1136,7 @@ _gf_msg_nomem(const char *domain, const char *file, const char *function,
     ret = gettimeofday(&tv, NULL);
     if (-1 == ret)
         goto out;
-    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
 
     /* TODO: Currently we print in the enhanced format, with a message ID
      * of 0. Need to enhance this to support format as configured */
@@ -1306,7 +1306,7 @@ gf_log_glusterlog(glusterfs_ctx_t *ctx, const char *domain, const char *file,
     gf_log_rotate(ctx);
 
     /* format the time stamp */
-    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
 
     /* generate footer */
     if (errnum) {
@@ -1410,8 +1410,10 @@ gf_syslog_log_repetitions(const char *domain, const char *file,
 
     SET_LOG_PRIO(level, priority);
 
-    gf_time_fmt_tv_FT(timestr_latest, sizeof timestr_latest, &latest, ctx);
-    gf_time_fmt_tv_FT(timestr_oldest, sizeof timestr_oldest, &oldest, ctx);
+    gf_time_fmt_tv_FT(timestr_latest, sizeof timestr_latest, &latest,
+                      &ctx->log);
+    gf_time_fmt_tv_FT(timestr_oldest, sizeof timestr_oldest, &oldest,
+                      &ctx->log);
 
     if (errnum) {
         syslog(priority,
@@ -1469,9 +1471,11 @@ gf_glusterlog_log_repetitions(glusterfs_ctx_t *ctx, const char *domain,
         goto err;
     }
 
-    gf_time_fmt_tv_FT(timestr_latest, sizeof timestr_latest, &latest, ctx);
+    gf_time_fmt_tv_FT(timestr_latest, sizeof timestr_latest, &latest,
+                      &ctx->log);
 
-    gf_time_fmt_tv_FT(timestr_oldest, sizeof timestr_oldest, &oldest, ctx);
+    gf_time_fmt_tv_FT(timestr_oldest, sizeof timestr_oldest, &oldest,
+                      &ctx->log);
 
     if (errnum)
         snprintf(errstr, sizeof(errstr) - 1, " [%s]", strerror(errnum));
@@ -2105,7 +2109,7 @@ _gf_log(const char *domain, const char *file, const char *function, int line,
     if (-1 == ret)
         goto out;
 
-    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
 
     ret = gf_asprintf(&logline, "[%s] %c [%s:%d:%s] %d-%s: %s\n", timestr,
                       gf_level_strings[level], basename, line, function,
@@ -2262,7 +2266,7 @@ gf_cmd_log(const char *domain, const char *fmt, ...)
         goto out;
     }
 
-    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+    gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
 
     ret = gf_asprintf(&logline, "[%s] %s : %s\n", timestr, domain, msg);
     if (ret == -1) {
diff --git a/libglusterfs/src/statedump.c b/libglusterfs/src/statedump.c
index 34ad2e7cdf3..39edc57b1cd 100644
--- a/libglusterfs/src/statedump.c
+++ b/libglusterfs/src/statedump.c
@@ -915,7 +915,7 @@ gf_proc_dump_info(int signum, glusterfs_ctx_t *ctx)
     // continue even though gettimeofday() has failed
     ret = gettimeofday(&tv, NULL);
     if (0 == ret) {
-        gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+        gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
         len = snprintf(sign_string, sizeof(sign_string),
                        "DUMP-START-TIME: %s\n", timestr);
 
@@ -961,7 +961,7 @@ gf_proc_dump_info(int signum, glusterfs_ctx_t *ctx)
 
     ret = gettimeofday(&tv, NULL);
     if (0 == ret) {
-        gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, ctx);
+        gf_time_fmt_tv_FT(timestr, sizeof timestr, &tv, &ctx->log);
         len = snprintf(sign_string, sizeof(sign_string), "\nDUMP-END-TIME: %s",
                        timestr);
         (void)sys_write(gf_dump_fd, sign_string, len);
diff --git a/xlators/debug/io-stats/src/io-stats.c b/xlators/debug/io-stats/src/io-stats.c
index 69d67239bf1..aa8418624da 100644
--- a/xlators/debug/io-stats/src/io-stats.c
+++ b/xlators/debug/io-stats/src/io-stats.c
@@ -666,7 +666,7 @@ ios_dump_file_stats(struct ios_stat_head *list_head, xlator_t *this,
     return 0;
 }
 
-int
+static int
 ios_dump_throughput_stats(struct ios_stat_head *list_head, xlator_t *this,
                           FILE *logfp, ios_stats_thru_t type)
 {
@@ -676,12 +676,16 @@ ios_dump_throughput_stats(struct ios_stat_head *list_head, xlator_t *this,
     };
     glusterfs_ctx_t *ctx = this->ctx;
 
+    if (ctx == NULL)
+        return 0;
+
     LOCK(&list_head->lock);
     {
         list_for_each_entry(entry, &list_head->iosstats->list, list)
         {
             gf_time_fmt_tv_FT(timestr, sizeof timestr,
-                              &entry->iosstat->thru_counters[type].time, ctx);
+                              &entry->iosstat->thru_counters[type].time,
+                              &ctx->log);
 
             ios_log(this, logfp, "%s \t %-10.2f  \t  %s", timestr, entry->value,
                     entry->iosstat->filename);
@@ -1287,7 +1291,7 @@ io_stats_dump_latency_samples_logfp(xlator_t *this, FILE *logfp)
     return ret;
 }
 
-int
+static int
 io_stats_dump_global_to_logfp(xlator_t *this, struct ios_global_stats *stats,
                               time_t now, int interval, FILE *logfp)
 {
@@ -1305,8 +1309,13 @@ io_stats_dump_global_to_logfp(xlator_t *this, struct ios_global_stats *stats,
     uint64_t fop_hits = 0;
     uint64_t block_count_read = 0;
     uint64_t block_count_write = 0;
+    glusterfs_ctx_t *ctx;
 
     conf = this->private;
+    ctx = this->ctx;
+
+    if (ctx == NULL)
+        return 0;
 
     if (interval == -1)
         ios_log(this, logfp, "\n=== Cumulative stats ===");
@@ -1406,7 +1415,7 @@ io_stats_dump_global_to_logfp(xlator_t *this, struct ios_global_stats *stats,
         LOCK(&conf->lock);
         {
             gf_time_fmt_tv_FT(timestr, sizeof timestr,
-                              &conf->cumulative.max_openfd_time, this->ctx);
+                              &conf->cumulative.max_openfd_time, &ctx->log);
             ios_log(this, logfp,
                     "Current open fd's: %" PRId64 " Max open fd's: %" PRId64
                     " time %s",
@@ -1861,7 +1870,7 @@ update_ios_latency(struct ios_conf *conf, call_frame_t *frame,
     return 0;
 }
 
-int32_t
+static int32_t
 io_stats_dump_stats_to_dict(xlator_t *this, dict_t *resp,
                             ios_stats_type_t flags, int32_t list_cnt)
 {
@@ -1877,8 +1886,13 @@ io_stats_dump_stats_to_dict(xlator_t *this, dict_t *resp,
         0,
     };
     char *dict_timestr = NULL;
+    glusterfs_ctx_t *ctx;
 
     conf = this->private;
+    ctx = this->ctx;
+
+    if (ctx == NULL)
+        goto out;
 
     switch (flags) {
         case IOS_STATS_TYPE_OPEN:
@@ -1893,7 +1907,7 @@ io_stats_dump_stats_to_dict(xlator_t *this, dict_t *resp,
                                       conf->cumulative.max_nr_opens);
 
                 gf_time_fmt_tv_FT(timestr, sizeof timestr,
-                                  &conf->cumulative.max_openfd_time, this->ctx);
+                                  &conf->cumulative.max_openfd_time, &ctx->log);
 
                 dict_timestr = gf_strdup(timestr);
                 if (!dict_timestr)
